from dataclasses import dataclass

@dataclass
class Params:
    select: str
    where: str

@dataclass
class Csv:
    path: str

@dataclass
class RestAPI:
    base_url: str
    authorization: str
    accept: str
    key: str
    param: Params

@dataclass
class Postgresql:
    host: str
    user: str
    password: str
    timeout: int
    max_retries: int
    port: int
    database: str

@dataclass
class Mysql:
    host: str
    user: str
    password: str
    port: int
    database: str

@dataclass
class Connection:
    alias: str
    type: str
    csv : Csv = None
    restapi: RestAPI = None
    postgresql: Postgresql = None
    mysql: Mysql = None